<VirtualHost *:80>
   ServerName {{ app_domain | mandatory }}

   RewriteEngine On
   RewriteCond %{HTTPS} off
   RewriteRule ^(.*)$ https://%{HTTP_HOST}$1 [R=301,L]
</VirtualHost>

<IfModule mod_ssl.c>
   <VirtualHost *:443>

     ServerName {{ app_domain }}
     DocumentRoot {{ app_instance_root }}

     SetEnvIFNoCase User-Agent "Monit" dontlog
     CustomLog {{ www_log }}/{{ app_instance_id }}/access.log combined env=!dontlog
     ErrorLog {{ www_log }}/{{ app_instance_id }}/error.log

     RewriteEngine On
     SSLProxyEngine on

     <Location />
        Order allow,deny
        Allow from all
     </Location>

     RewriteCond %{HTTP:Upgrade} =websocket [NC]
     RewriteRule /(.*)           ws://localhost:{{ app_port }}/$1 [P,L]
     RewriteCond %{HTTP:Upgrade} !=websocket [NC]
     RewriteRule /(.*)           http://localhost:{{ app_port }}/$1 [P,L]

     ProxyPassReverse / http://localhost:{{ app_port }}/

     SSLEngine on
     SSLCertificateFile /etc/letsencrypt/live/{{ app_domain }}/fullchain.pem
     SSLCertificateKeyFile /etc/letsencrypt/live/{{ app_domain }}/privkey.pem

     </VirtualHost>
</IfModule>
